pragma Source_File_Name (ada_main, Spec_File_Name => "b~gate.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b~gate.adb");

package body ada_main is
   pragma Warnings (Off);

   procedure Do_Finalize;
   pragma Import (C, Do_Finalize, "system__standard_library__adafinal");

   procedure adainit is
      E049 : Boolean; pragma Import (Ada, E049, "system__restrictions_E");
      E009 : Boolean; pragma Import (Ada, E009, "system__secondary_stack_E");
      E015 : Boolean; pragma Import (Ada, E015, "ada__exceptions_E");
      E013 : Boolean; pragma Import (Ada, E013, "system__soft_links_E");
      E019 : Boolean; pragma Import (Ada, E019, "system__exception_table_E");
      E056 : Boolean; pragma Import (Ada, E056, "ada__io_exceptions_E");
      E072 : Boolean; pragma Import (Ada, E072, "ada__strings_E");
      E035 : Boolean; pragma Import (Ada, E035, "ada__tags_E");
      E033 : Boolean; pragma Import (Ada, E033, "ada__streams_E");
      E110 : Boolean; pragma Import (Ada, E110, "gnat__os_lib_E");
      E063 : Boolean; pragma Import (Ada, E063, "interfaces__c_E");
      E065 : Boolean; pragma Import (Ada, E065, "interfaces__c__strings_E");
      E192 : Boolean; pragma Import (Ada, E192, "system__assertions_E");
      E045 : Boolean; pragma Import (Ada, E045, "system__finalization_root_E");
      E074 : Boolean; pragma Import (Ada, E074, "ada__strings__maps_E");
      E078 : Boolean; pragma Import (Ada, E078, "ada__strings__maps__constants_E");
      E047 : Boolean; pragma Import (Ada, E047, "system__finalization_implementation_E");
      E043 : Boolean; pragma Import (Ada, E043, "ada__finalization_E");
      E059 : Boolean; pragma Import (Ada, E059, "ada__finalization__list_controller_E");
      E057 : Boolean; pragma Import (Ada, E057, "system__file_control_block_E");
      E041 : Boolean; pragma Import (Ada, E041, "system__file_io_E");
      E032 : Boolean; pragma Import (Ada, E032, "ada__text_io_E");
      E061 : Boolean; pragma Import (Ada, E061, "glib_E");
      E132 : Boolean; pragma Import (Ada, E132, "gdk__rectangle_E");
      E147 : Boolean; pragma Import (Ada, E147, "glib__glist_E");
      E145 : Boolean; pragma Import (Ada, E145, "gdk__visual_E");
      E091 : Boolean; pragma Import (Ada, E091, "glib__gslist_E");
      E137 : Boolean; pragma Import (Ada, E137, "glib__values_E");
      E099 : Boolean; pragma Import (Ada, E099, "glib__xml_E");
      E067 : Boolean; pragma Import (Ada, E067, "glib__glade_E");
      E122 : Boolean; pragma Import (Ada, E122, "gtk_generates_E");
      E089 : Boolean; pragma Import (Ada, E089, "gtkada__types_E");
      E084 : Boolean; pragma Import (Ada, E084, "glib__object_E");
      E143 : Boolean; pragma Import (Ada, E143, "gdk__color_E");
      E190 : Boolean; pragma Import (Ada, E190, "gdk__cursor_E");
      E135 : Boolean; pragma Import (Ada, E135, "glib__generic_properties_E");
      E086 : Boolean; pragma Import (Ada, E086, "glib__type_conversion_hooks_E");
      E172 : Boolean; pragma Import (Ada, E172, "gdk__region_E");
      E130 : Boolean; pragma Import (Ada, E130, "gdk__event_E");
      E139 : Boolean; pragma Import (Ada, E139, "gdk__window_E");
      E162 : Boolean; pragma Import (Ada, E162, "gdk__bitmap_E");
      E174 : Boolean; pragma Import (Ada, E174, "gdk__pixmap_E");
      E178 : Boolean; pragma Import (Ada, E178, "glib__properties_E");
      E186 : Boolean; pragma Import (Ada, E186, "gtk__enums_E");
      E118 : Boolean; pragma Import (Ada, E118, "gtk__glade_E");
      E182 : Boolean; pragma Import (Ada, E182, "gtk__object_E");
      E180 : Boolean; pragma Import (Ada, E180, "gtk__accel_group_E");
      E184 : Boolean; pragma Import (Ada, E184, "gtk__adjustment_E");
      E154 : Boolean; pragma Import (Ada, E154, "pango__enums_E");
      E158 : Boolean; pragma Import (Ada, E158, "pango__attributes_E");
      E152 : Boolean; pragma Import (Ada, E152, "pango__font_E");
      E170 : Boolean; pragma Import (Ada, E170, "gdk__font_E");
      E168 : Boolean; pragma Import (Ada, E168, "gdk__gc_E");
      E188 : Boolean; pragma Import (Ada, E188, "gtk__style_E");
      E150 : Boolean; pragma Import (Ada, E150, "pango__context_E");
      E160 : Boolean; pragma Import (Ada, E160, "pango__tabs_E");
      E156 : Boolean; pragma Import (Ada, E156, "pango__layout_E");
      E166 : Boolean; pragma Import (Ada, E166, "gdk__drawable_E");
      E176 : Boolean; pragma Import (Ada, E176, "gdk__rgb_E");
      E164 : Boolean; pragma Import (Ada, E164, "gdk__pixbuf_E");
      E141 : Boolean; pragma Import (Ada, E141, "gtk__widget_E");

      Restrictions : constant String :=
        "nnvvnnnvvnnvnnvnvvvvvvnvvnvnvnnvnnnvnvnnnnnnnvvvvnnnrvvvv" &
        "nnnnnnnnnnnnnn" & ASCII.Nul;

      Interrupt_States : constant String :=
        "";

      procedure Set_Globals
        (Main_Priority            : Integer;
         Time_Slice_Value         : Integer;
         WC_Encoding              : Character;
         Locking_Policy           : Character;
         Queuing_Policy           : Character;
         Task_Dispatching_Policy  : Character;
         Restrictions             : System.Address;
         Interrupt_States         : System.Address;
         Num_Interrupt_States     : Integer;
         Unreserve_All_Interrupts : Integer;
         Exception_Tracebacks     : Integer;
         Zero_Cost_Exceptions     : Integer;
         Detect_Blocking          : Integer);
      pragma Import (C, Set_Globals, "__gnat_set_globals");

      procedure Install_Handler;
      pragma Import (C, Install_Handler, "__gnat_install_handler");

      Handler_Installed : Integer;
      pragma Import (C, Handler_Installed, "__gnat_handler_installed");
   begin
      Set_Globals
        (Main_Priority            => -1,
         Time_Slice_Value         => -1,
         WC_Encoding              => 'b',
         Locking_Policy           => ' ',
         Queuing_Policy           => ' ',
         Task_Dispatching_Policy  => ' ',
         Restrictions             => Restrictions'Address,
         Interrupt_States         => Interrupt_States'Address,
         Num_Interrupt_States     => 0,
         Unreserve_All_Interrupts => 0,
         Exception_Tracebacks     => 0,
         Zero_Cost_Exceptions     => 1,
         Detect_Blocking          => 0);

      if Handler_Installed = 0 then
         Install_Handler;
      end if;

      System.Restrictions'Elab_Spec;
      System.Restrictions'Elab_Body;
      E049 := True;
      Ada.Exceptions'Elab_Spec;
      System.Soft_Links'Elab_Body;
      E013 := True;
      System.Secondary_Stack'Elab_Body;
      E009 := True;
      System.Exception_Table'Elab_Body;
      E019 := True;
      Ada.Io_Exceptions'Elab_Spec;
      E056 := True;
      Ada.Strings'Elab_Spec;
      E072 := True;
      Ada.Tags'Elab_Spec;
      Ada.Tags'Elab_Body;
      E035 := True;
      Ada.Streams'Elab_Spec;
      E033 := True;
      Gnat.Os_Lib'Elab_Body;
      E110 := True;
      Interfaces.C'Elab_Spec;
      E063 := True;
      Interfaces.C.Strings'Elab_Spec;
      E065 := True;
      System.Assertions'Elab_Spec;
      E192 := True;
      System.Finalization_Root'Elab_Spec;
      E045 := True;
      E015 := True;
      Ada.Strings.Maps'Elab_Spec;
      E074 := True;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E078 := True;
      System.Finalization_Implementation'Elab_Spec;
      System.Finalization_Implementation'Elab_Body;
      E047 := True;
      Ada.Finalization'Elab_Spec;
      E043 := True;
      Ada.Finalization.List_Controller'Elab_Spec;
      E059 := True;
      System.File_Control_Block'Elab_Spec;
      E057 := True;
      System.File_Io'Elab_Body;
      E041 := True;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E032 := True;
      Glib'Elab_Spec;
      E061 := True;
      E132 := True;
      E147 := True;
      Gdk.Visual'Elab_Body;
      E145 := True;
      E091 := True;
      Glib.Values'Elab_Body;
      E137 := True;
      E099 := True;
      E122 := True;
      Gtkada.Types'Elab_Spec;
      E089 := True;
      Glib.Object'Elab_Spec;
      Glib.Glade'Elab_Body;
      E067 := True;
      Gdk.Color'Elab_Spec;
      E190 := True;
      Glib.Generic_Properties'Elab_Body;
      E135 := True;
      E086 := True;
      E084 := True;
      E143 := True;
      E172 := True;
      Gdk.Event'Elab_Spec;
      E130 := True;
      E162 := True;
      E174 := True;
      E178 := True;
      E186 := True;
      Gtk.Glade'Elab_Body;
      E118 := True;
      Gtk.Object'Elab_Spec;
      E182 := True;
      Gtk.Accel_Group'Elab_Spec;
      Gtk.Accel_Group'Elab_Body;
      E180 := True;
      Gtk.Adjustment'Elab_Spec;
      E184 := True;
      E154 := True;
      E158 := True;
      Pango.Font'Elab_Spec;
      E152 := True;
      E170 := True;
      E168 := True;
      E188 := True;
      Pango.Context'Elab_Spec;
      E150 := True;
      E160 := True;
      Pango.Layout'Elab_Spec;
      E156 := True;
      E166 := True;
      E176 := True;
      E164 := True;
      Gtk.Widget'Elab_Spec;
      E141 := True;
      E139 := True;
   end adainit;

   procedure adafinal is
   begin
      Do_Finalize;
   end adafinal;

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure initialize (Addr : System.Address);
      pragma Import (C, initialize, "__gnat_initialize");

      procedure finalize;
      pragma Import (C, finalize, "__gnat_finalize");

      procedure Ada_Main_Program;
      pragma Import (Ada, Ada_Main_Program, "_ada_gate");

      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : System.Address := Ada_Main_Program_Name'Address;

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Break_Start;
      Ada_Main_Program;
      Do_Finalize;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   ./gtk_generates.o
   --   ./gtk-glade.o
   --   ./gate.o
   --   -L./
   --   -L/usr/lib/gcc/ppc64-redhat-linux/4.1.1/adalib/
   --   -shared
   --   -lgnat-4.1
--  END Object file/option list   

end ada_main;
