with System;
package ada_main is
   pragma Warnings (Off);

   gnat_argc : Integer;
   gnat_argv : System.Address;
   gnat_envp : System.Address;

   pragma Import (C, gnat_argc);
   pragma Import (C, gnat_argv);
   pragma Import (C, gnat_envp);

   gnat_exit_status : Integer;
   pragma Import (C, gnat_exit_status);

   GNAT_Version : constant String :=
                    "GNAT Version: 4.1.1 20070102 (Red Hat 4.1.1-51)";
   pragma Export (C, GNAT_Version, "__gnat_version");

   Ada_Main_Program_Name : constant String := "_ada_gate" & Ascii.NUL;
   pragma Export (C, Ada_Main_Program_Name, "__gnat_ada_main_program_name");

   procedure adafinal;
   pragma Export (C, adafinal, "adafinal");

   procedure adainit;
   pragma Export (C, adainit, "adainit");

   procedure Break_Start;
   pragma Import (C, Break_Start, "__gnat_break_start");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer;
   pragma Export (C, main, "main");

   type Version_32 is mod 2 ** 32;
   u00001 : constant Version_32 := 16#36fc1888#;
   u00002 : constant Version_32 := 16#a13e7998#;
   u00003 : constant Version_32 := 16#ad6baf6a#;
   u00004 : constant Version_32 := 16#9c7dd3ea#;
   u00005 : constant Version_32 := 16#161b126d#;
   u00006 : constant Version_32 := 16#a70c0a76#;
   u00007 : constant Version_32 := 16#7ba4417a#;
   u00008 : constant Version_32 := 16#4f2efc57#;
   u00009 : constant Version_32 := 16#570b8748#;
   u00010 : constant Version_32 := 16#5e649d41#;
   u00011 : constant Version_32 := 16#1073f90e#;
   u00012 : constant Version_32 := 16#664dc45d#;
   u00013 : constant Version_32 := 16#a3c5e83c#;
   u00014 : constant Version_32 := 16#b6a7f13e#;
   u00015 : constant Version_32 := 16#e80c7d18#;
   u00016 : constant Version_32 := 16#a8622740#;
   u00017 : constant Version_32 := 16#b4a43d48#;
   u00018 : constant Version_32 := 16#9e79739c#;
   u00019 : constant Version_32 := 16#0302f122#;
   u00020 : constant Version_32 := 16#726beeed#;
   u00021 : constant Version_32 := 16#ee3c8ede#;
   u00022 : constant Version_32 := 16#60f858a1#;
   u00023 : constant Version_32 := 16#8c4dea44#;
   u00024 : constant Version_32 := 16#1e1b7442#;
   u00025 : constant Version_32 := 16#c04c44c4#;
   u00026 : constant Version_32 := 16#c83d58f0#;
   u00027 : constant Version_32 := 16#264aa8fc#;
   u00028 : constant Version_32 := 16#e2f48611#;
   u00029 : constant Version_32 := 16#36281ef1#;
   u00030 : constant Version_32 := 16#8bad874e#;
   u00031 : constant Version_32 := 16#ba8c95aa#;
   u00032 : constant Version_32 := 16#2c9af4b8#;
   u00033 : constant Version_32 := 16#b8165b4c#;
   u00034 : constant Version_32 := 16#4890dbc3#;
   u00035 : constant Version_32 := 16#81c2842a#;
   u00036 : constant Version_32 := 16#a69cad5c#;
   u00037 : constant Version_32 := 16#0a3f4443#;
   u00038 : constant Version_32 := 16#6754120e#;
   u00039 : constant Version_32 := 16#54b31bcc#;
   u00040 : constant Version_32 := 16#9d0ab023#;
   u00041 : constant Version_32 := 16#089039d5#;
   u00042 : constant Version_32 := 16#21d0aa8a#;
   u00043 : constant Version_32 := 16#cbe3065c#;
   u00044 : constant Version_32 := 16#9f3a536c#;
   u00045 : constant Version_32 := 16#139ff77e#;
   u00046 : constant Version_32 := 16#0aa1d10e#;
   u00047 : constant Version_32 := 16#30b1ee7a#;
   u00048 : constant Version_32 := 16#65af5a34#;
   u00049 : constant Version_32 := 16#17414e05#;
   u00050 : constant Version_32 := 16#373bd87b#;
   u00051 : constant Version_32 := 16#6f681a8c#;
   u00052 : constant Version_32 := 16#63c7c118#;
   u00053 : constant Version_32 := 16#e943d86e#;
   u00054 : constant Version_32 := 16#1172f591#;
   u00055 : constant Version_32 := 16#0fd19777#;
   u00056 : constant Version_32 := 16#2274d34a#;
   u00057 : constant Version_32 := 16#37beb305#;
   u00058 : constant Version_32 := 16#9714d691#;
   u00059 : constant Version_32 := 16#c507a69c#;
   u00060 : constant Version_32 := 16#56320f3f#;
   u00061 : constant Version_32 := 16#543196c6#;
   u00062 : constant Version_32 := 16#456f00e8#;
   u00063 : constant Version_32 := 16#6d4a96e7#;
   u00064 : constant Version_32 := 16#f635e436#;
   u00065 : constant Version_32 := 16#684fa915#;
   u00066 : constant Version_32 := 16#dfda6b75#;
   u00067 : constant Version_32 := 16#43d85f52#;
   u00068 : constant Version_32 := 16#cc1134cf#;
   u00069 : constant Version_32 := 16#0d7da1e0#;
   u00070 : constant Version_32 := 16#b19439a7#;
   u00071 : constant Version_32 := 16#60144c8b#;
   u00072 : constant Version_32 := 16#1bc9f0e1#;
   u00073 : constant Version_32 := 16#b508dc1a#;
   u00074 : constant Version_32 := 16#bc5c2342#;
   u00075 : constant Version_32 := 16#b31779d5#;
   u00076 : constant Version_32 := 16#04e247f8#;
   u00077 : constant Version_32 := 16#da0cfc1f#;
   u00078 : constant Version_32 := 16#6c2ffb17#;
   u00079 : constant Version_32 := 16#29346572#;
   u00080 : constant Version_32 := 16#a91ece26#;
   u00081 : constant Version_32 := 16#6370ea61#;
   u00082 : constant Version_32 := 16#0d2e6c3e#;
   u00083 : constant Version_32 := 16#e19e2c8a#;
   u00084 : constant Version_32 := 16#015b979c#;
   u00085 : constant Version_32 := 16#5b5e3696#;
   u00086 : constant Version_32 := 16#a2a6d6a6#;
   u00087 : constant Version_32 := 16#1096f5e5#;
   u00088 : constant Version_32 := 16#4299ce99#;
   u00089 : constant Version_32 := 16#6a734d9d#;
   u00090 : constant Version_32 := 16#4ff87478#;
   u00091 : constant Version_32 := 16#25d94024#;
   u00092 : constant Version_32 := 16#f04bf624#;
   u00093 : constant Version_32 := 16#59c2523c#;
   u00094 : constant Version_32 := 16#4c526528#;
   u00095 : constant Version_32 := 16#a703b301#;
   u00096 : constant Version_32 := 16#56af4987#;
   u00097 : constant Version_32 := 16#1861ec62#;
   u00098 : constant Version_32 := 16#9362bbb1#;
   u00099 : constant Version_32 := 16#4412c201#;
   u00100 : constant Version_32 := 16#805087e8#;
   u00101 : constant Version_32 := 16#d75135a7#;
   u00102 : constant Version_32 := 16#7a5996c3#;
   u00103 : constant Version_32 := 16#41c5e5a0#;
   u00104 : constant Version_32 := 16#c507a643#;
   u00105 : constant Version_32 := 16#d7b4d3a0#;
   u00106 : constant Version_32 := 16#2977527a#;
   u00107 : constant Version_32 := 16#f98672f4#;
   u00108 : constant Version_32 := 16#96410e68#;
   u00109 : constant Version_32 := 16#f393ccd8#;
   u00110 : constant Version_32 := 16#aa2ef2ae#;
   u00111 : constant Version_32 := 16#b7140ae3#;
   u00112 : constant Version_32 := 16#ec136a81#;
   u00113 : constant Version_32 := 16#c5c1ddd4#;
   u00114 : constant Version_32 := 16#645877a3#;
   u00115 : constant Version_32 := 16#bbe85e72#;
   u00116 : constant Version_32 := 16#8563d2a1#;
   u00117 : constant Version_32 := 16#13965474#;
   u00118 : constant Version_32 := 16#8dc30478#;
   u00119 : constant Version_32 := 16#a1683194#;
   u00120 : constant Version_32 := 16#ab3e94ba#;
   u00121 : constant Version_32 := 16#d63f31f6#;
   u00122 : constant Version_32 := 16#c0a2fbab#;
   u00123 : constant Version_32 := 16#8028c86e#;
   u00124 : constant Version_32 := 16#17d2ccc4#;
   u00125 : constant Version_32 := 16#467b95c7#;
   u00126 : constant Version_32 := 16#d05cf709#;
   u00127 : constant Version_32 := 16#a7c5383a#;
   u00128 : constant Version_32 := 16#59e28a92#;
   u00129 : constant Version_32 := 16#5752b13d#;
   u00130 : constant Version_32 := 16#f65d47fc#;
   u00131 : constant Version_32 := 16#08ab1c13#;
   u00132 : constant Version_32 := 16#2fe6ef4f#;
   u00133 : constant Version_32 := 16#69a134f7#;
   u00134 : constant Version_32 := 16#12ecc7c2#;
   u00135 : constant Version_32 := 16#7ab3b5d7#;
   u00136 : constant Version_32 := 16#273c5b6b#;
   u00137 : constant Version_32 := 16#78261776#;
   u00138 : constant Version_32 := 16#f52d7c7b#;
   u00139 : constant Version_32 := 16#f3c643db#;
   u00140 : constant Version_32 := 16#28eb495d#;
   u00141 : constant Version_32 := 16#fc2561ba#;
   u00142 : constant Version_32 := 16#dc5a2fc6#;
   u00143 : constant Version_32 := 16#5fbf43b5#;
   u00144 : constant Version_32 := 16#f6c9e787#;
   u00145 : constant Version_32 := 16#2e1d1f2a#;
   u00146 : constant Version_32 := 16#e26ddb9f#;
   u00147 : constant Version_32 := 16#ff49da1d#;
   u00148 : constant Version_32 := 16#567c5424#;
   u00149 : constant Version_32 := 16#6fc0d7a9#;
   u00150 : constant Version_32 := 16#0d980bdf#;
   u00151 : constant Version_32 := 16#58358e40#;
   u00152 : constant Version_32 := 16#2bc98842#;
   u00153 : constant Version_32 := 16#970088c8#;
   u00154 : constant Version_32 := 16#d2414a30#;
   u00155 : constant Version_32 := 16#99f64ed5#;
   u00156 : constant Version_32 := 16#78de19ac#;
   u00157 : constant Version_32 := 16#e94289b8#;
   u00158 : constant Version_32 := 16#af53e7fc#;
   u00159 : constant Version_32 := 16#179e0e3d#;
   u00160 : constant Version_32 := 16#521bbf7c#;
   u00161 : constant Version_32 := 16#f56fa201#;
   u00162 : constant Version_32 := 16#40f27dbf#;
   u00163 : constant Version_32 := 16#5252f62e#;
   u00164 : constant Version_32 := 16#587f2d1b#;
   u00165 : constant Version_32 := 16#c8ecbbf9#;
   u00166 : constant Version_32 := 16#e69d914f#;
   u00167 : constant Version_32 := 16#34bc5b1a#;
   u00168 : constant Version_32 := 16#0fdc986f#;
   u00169 : constant Version_32 := 16#899b2c08#;
   u00170 : constant Version_32 := 16#7a82d2e1#;
   u00171 : constant Version_32 := 16#7b112dfc#;
   u00172 : constant Version_32 := 16#ba9b0424#;
   u00173 : constant Version_32 := 16#c3bc410e#;
   u00174 : constant Version_32 := 16#2991e97c#;
   u00175 : constant Version_32 := 16#ba753f14#;
   u00176 : constant Version_32 := 16#0193a311#;
   u00177 : constant Version_32 := 16#4f6eae3e#;
   u00178 : constant Version_32 := 16#a9be83e0#;
   u00179 : constant Version_32 := 16#8cfc230f#;
   u00180 : constant Version_32 := 16#7ae530bf#;
   u00181 : constant Version_32 := 16#4b148fb3#;
   u00182 : constant Version_32 := 16#f8af5e6e#;
   u00183 : constant Version_32 := 16#1665a95e#;
   u00184 : constant Version_32 := 16#302f1911#;
   u00185 : constant Version_32 := 16#b2711484#;
   u00186 : constant Version_32 := 16#de777a7c#;
   u00187 : constant Version_32 := 16#841d54c9#;
   u00188 : constant Version_32 := 16#f73af3c5#;
   u00189 : constant Version_32 := 16#2e7972b2#;
   u00190 : constant Version_32 := 16#0c49292b#;
   u00191 : constant Version_32 := 16#0cd379ea#;
   u00192 : constant Version_32 := 16#fef37b88#;
   u00193 : constant Version_32 := 16#adcdaba4#;
   u00194 : constant Version_32 := 16#481c3754#;

   pragma Export (C, u00001, "gateB");
   pragma Export (C, u00002, "system__standard_libraryB");
   pragma Export (C, u00003, "system__standard_libraryS");
   pragma Export (C, u00004, "adaS");
   pragma Export (C, u00005, "ada__command_lineB");
   pragma Export (C, u00006, "ada__command_lineS");
   pragma Export (C, u00007, "systemS");
   pragma Export (C, u00008, "system__secondary_stackB");
   pragma Export (C, u00009, "system__secondary_stackS");
   pragma Export (C, u00010, "system__parametersB");
   pragma Export (C, u00011, "system__parametersS");
   pragma Export (C, u00012, "system__soft_linksB");
   pragma Export (C, u00013, "system__soft_linksS");
   pragma Export (C, u00014, "ada__exceptionsB");
   pragma Export (C, u00015, "ada__exceptionsS");
   pragma Export (C, u00016, "ada__exceptions__last_chance_handlerB");
   pragma Export (C, u00017, "ada__exceptions__last_chance_handlerS");
   pragma Export (C, u00018, "system__exception_tableB");
   pragma Export (C, u00019, "system__exception_tableS");
   pragma Export (C, u00020, "system__htableB");
   pragma Export (C, u00021, "system__htableS");
   pragma Export (C, u00022, "system__storage_elementsB");
   pragma Export (C, u00023, "system__storage_elementsS");
   pragma Export (C, u00024, "system__tracebackB");
   pragma Export (C, u00025, "system__tracebackS");
   pragma Export (C, u00026, "system__unsigned_typesS");
   pragma Export (C, u00027, "system__traceback_entriesB");
   pragma Export (C, u00028, "system__traceback_entriesS");
   pragma Export (C, u00029, "system__stack_checkingB");
   pragma Export (C, u00030, "system__stack_checkingS");
   pragma Export (C, u00031, "ada__text_ioB");
   pragma Export (C, u00032, "ada__text_ioS");
   pragma Export (C, u00033, "ada__streamsS");
   pragma Export (C, u00034, "ada__tagsB");
   pragma Export (C, u00035, "ada__tagsS");
   pragma Export (C, u00036, "interfacesS");
   pragma Export (C, u00037, "interfaces__c_streamsB");
   pragma Export (C, u00038, "interfaces__c_streamsS");
   pragma Export (C, u00039, "system__crtlS");
   pragma Export (C, u00040, "system__file_ioB");
   pragma Export (C, u00041, "system__file_ioS");
   pragma Export (C, u00042, "ada__finalizationB");
   pragma Export (C, u00043, "ada__finalizationS");
   pragma Export (C, u00044, "system__finalization_rootB");
   pragma Export (C, u00045, "system__finalization_rootS");
   pragma Export (C, u00046, "system__finalization_implementationB");
   pragma Export (C, u00047, "system__finalization_implementationS");
   pragma Export (C, u00048, "system__restrictionsB");
   pragma Export (C, u00049, "system__restrictionsS");
   pragma Export (C, u00050, "system__string_ops_concat_3B");
   pragma Export (C, u00051, "system__string_ops_concat_3S");
   pragma Export (C, u00052, "system__string_opsB");
   pragma Export (C, u00053, "system__string_opsS");
   pragma Export (C, u00054, "system__stream_attributesB");
   pragma Export (C, u00055, "system__stream_attributesS");
   pragma Export (C, u00056, "ada__io_exceptionsS");
   pragma Export (C, u00057, "system__file_control_blockS");
   pragma Export (C, u00058, "ada__finalization__list_controllerB");
   pragma Export (C, u00059, "ada__finalization__list_controllerS");
   pragma Export (C, u00060, "glibB");
   pragma Export (C, u00061, "glibS");
   pragma Export (C, u00062, "interfaces__cB");
   pragma Export (C, u00063, "interfaces__cS");
   pragma Export (C, u00064, "interfaces__c__stringsB");
   pragma Export (C, u00065, "interfaces__c__stringsS");
   pragma Export (C, u00066, "glib__gladeB");
   pragma Export (C, u00067, "glib__gladeS");
   pragma Export (C, u00068, "ada__charactersS");
   pragma Export (C, u00069, "ada__characters__handlingB");
   pragma Export (C, u00070, "ada__characters__handlingS");
   pragma Export (C, u00071, "ada__characters__latin_1S");
   pragma Export (C, u00072, "ada__stringsS");
   pragma Export (C, u00073, "ada__strings__mapsB");
   pragma Export (C, u00074, "ada__strings__mapsS");
   pragma Export (C, u00075, "system__bit_opsB");
   pragma Export (C, u00076, "system__bit_opsS");
   pragma Export (C, u00077, "system__pure_exceptionsS");
   pragma Export (C, u00078, "ada__strings__maps__constantsS");
   pragma Export (C, u00079, "ada__strings__fixedB");
   pragma Export (C, u00080, "ada__strings__fixedS");
   pragma Export (C, u00081, "ada__strings__searchB");
   pragma Export (C, u00082, "ada__strings__searchS");
   pragma Export (C, u00083, "glib__objectB");
   pragma Export (C, u00084, "glib__objectS");
   pragma Export (C, u00085, "glib__type_conversion_hooksB");
   pragma Export (C, u00086, "glib__type_conversion_hooksS");
   pragma Export (C, u00087, "gtkadaS");
   pragma Export (C, u00088, "gtkada__typesB");
   pragma Export (C, u00089, "gtkada__typesS");
   pragma Export (C, u00090, "glib__gslistB");
   pragma Export (C, u00091, "glib__gslistS");
   pragma Export (C, u00092, "system__img_unsB");
   pragma Export (C, u00093, "system__img_unsS");
   pragma Export (C, u00094, "system__string_ops_concat_4B");
   pragma Export (C, u00095, "system__string_ops_concat_4S");
   pragma Export (C, u00096, "system__string_ops_concat_5B");
   pragma Export (C, u00097, "system__string_ops_concat_5S");
   pragma Export (C, u00098, "glib__xmlB");
   pragma Export (C, u00099, "glib__xmlS");
   pragma Export (C, u00100, "glib__convertB");
   pragma Export (C, u00101, "glib__convertS");
   pragma Export (C, u00102, "glib__errorB");
   pragma Export (C, u00103, "glib__errorS");
   pragma Export (C, u00104, "glib__messagesB");
   pragma Export (C, u00105, "glib__messagesS");
   pragma Export (C, u00106, "system__img_intB");
   pragma Export (C, u00107, "system__img_intS");
   pragma Export (C, u00108, "gnatS");
   pragma Export (C, u00109, "gnat__os_libB");
   pragma Export (C, u00110, "gnat__os_libS");
   pragma Export (C, u00111, "system__case_utilB");
   pragma Export (C, u00112, "system__case_utilS");
   pragma Export (C, u00113, "gnat__stringsB");
   pragma Export (C, u00114, "gnat__stringsS");
   pragma Export (C, u00115, "gtkS");
   pragma Export (C, u00116, "gdkS");
   pragma Export (C, u00117, "gtk__gladeB");
   pragma Export (C, u00118, "gtk__gladeS");
   pragma Export (C, u00119, "gnat__htableB");
   pragma Export (C, u00120, "gnat__htableS");
   pragma Export (C, u00121, "gtk_generatesB");
   pragma Export (C, u00122, "gtk_generatesS");
   pragma Export (C, u00123, "system__val_boolB");
   pragma Export (C, u00124, "system__val_boolS");
   pragma Export (C, u00125, "system__val_utilB");
   pragma Export (C, u00126, "system__val_utilS");
   pragma Export (C, u00127, "gtk__mainB");
   pragma Export (C, u00128, "gtk__mainS");
   pragma Export (C, u00129, "gdk__eventB");
   pragma Export (C, u00130, "gdk__eventS");
   pragma Export (C, u00131, "gdk__rectangleB");
   pragma Export (C, u00132, "gdk__rectangleS");
   pragma Export (C, u00133, "gdk__typesS");
   pragma Export (C, u00134, "glib__generic_propertiesB");
   pragma Export (C, u00135, "glib__generic_propertiesS");
   pragma Export (C, u00136, "glib__valuesB");
   pragma Export (C, u00137, "glib__valuesS");
   pragma Export (C, u00138, "gdk__windowB");
   pragma Export (C, u00139, "gdk__windowS");
   pragma Export (C, u00140, "gtk__widgetB");
   pragma Export (C, u00141, "gtk__widgetS");
   pragma Export (C, u00142, "gdk__colorB");
   pragma Export (C, u00143, "gdk__colorS");
   pragma Export (C, u00144, "gdk__visualB");
   pragma Export (C, u00145, "gdk__visualS");
   pragma Export (C, u00146, "glib__glistB");
   pragma Export (C, u00147, "glib__glistS");
   pragma Export (C, u00148, "pangoS");
   pragma Export (C, u00149, "pango__contextB");
   pragma Export (C, u00150, "pango__contextS");
   pragma Export (C, u00151, "pango__fontB");
   pragma Export (C, u00152, "pango__fontS");
   pragma Export (C, u00153, "pango__enumsB");
   pragma Export (C, u00154, "pango__enumsS");
   pragma Export (C, u00155, "pango__layoutB");
   pragma Export (C, u00156, "pango__layoutS");
   pragma Export (C, u00157, "pango__attributesB");
   pragma Export (C, u00158, "pango__attributesS");
   pragma Export (C, u00159, "pango__tabsB");
   pragma Export (C, u00160, "pango__tabsS");
   pragma Export (C, u00161, "gdk__bitmapB");
   pragma Export (C, u00162, "gdk__bitmapS");
   pragma Export (C, u00163, "gdk__pixbufB");
   pragma Export (C, u00164, "gdk__pixbufS");
   pragma Export (C, u00165, "gdk__drawableB");
   pragma Export (C, u00166, "gdk__drawableS");
   pragma Export (C, u00167, "gdk__gcB");
   pragma Export (C, u00168, "gdk__gcS");
   pragma Export (C, u00169, "gdk__fontB");
   pragma Export (C, u00170, "gdk__fontS");
   pragma Export (C, u00171, "gdk__regionB");
   pragma Export (C, u00172, "gdk__regionS");
   pragma Export (C, u00173, "gdk__pixmapB");
   pragma Export (C, u00174, "gdk__pixmapS");
   pragma Export (C, u00175, "gdk__rgbB");
   pragma Export (C, u00176, "gdk__rgbS");
   pragma Export (C, u00177, "glib__propertiesB");
   pragma Export (C, u00178, "glib__propertiesS");
   pragma Export (C, u00179, "gtk__accel_groupB");
   pragma Export (C, u00180, "gtk__accel_groupS");
   pragma Export (C, u00181, "gtk__objectB");
   pragma Export (C, u00182, "gtk__objectS");
   pragma Export (C, u00183, "gtk__adjustmentB");
   pragma Export (C, u00184, "gtk__adjustmentS");
   pragma Export (C, u00185, "gtk__enumsB");
   pragma Export (C, u00186, "gtk__enumsS");
   pragma Export (C, u00187, "gtk__styleB");
   pragma Export (C, u00188, "gtk__styleS");
   pragma Export (C, u00189, "gdk__cursorB");
   pragma Export (C, u00190, "gdk__cursorS");
   pragma Export (C, u00191, "system__assertionsB");
   pragma Export (C, u00192, "system__assertionsS");
   pragma Export (C, u00193, "system__memoryB");
   pragma Export (C, u00194, "system__memoryS");

   --  BEGIN ELABORATION ORDER
   --  ada%s
   --  ada.characters%s
   --  ada.characters.handling%s
   --  ada.characters.latin_1%s
   --  ada.command_line%s
   --  gnat%s
   --  gnat.strings%s
   --  gnat.strings%b
   --  interfaces%s
   --  system%s
   --  system.bit_ops%s
   --  system.case_util%s
   --  system.case_util%b
   --  system.htable%s
   --  system.htable%b
   --  gnat.htable%s
   --  gnat.htable%b
   --  system.img_int%s
   --  system.parameters%s
   --  system.parameters%b
   --  system.crtl%s
   --  interfaces.c_streams%s
   --  interfaces.c_streams%b
   --  system.pure_exceptions%s
   --  system.restrictions%s
   --  system.restrictions%b
   --  system.standard_library%s
   --  system.storage_elements%s
   --  system.storage_elements%b
   --  system.secondary_stack%s
   --  system.img_int%b
   --  ada.command_line%b
   --  system.stack_checking%s
   --  system.stack_checking%b
   --  system.string_ops%s
   --  system.string_ops%b
   --  system.string_ops_concat_3%s
   --  system.string_ops_concat_3%b
   --  system.string_ops_concat_4%s
   --  system.string_ops_concat_4%b
   --  system.string_ops_concat_5%s
   --  system.string_ops_concat_5%b
   --  system.traceback%s
   --  system.traceback%b
   --  system.traceback_entries%s
   --  system.traceback_entries%b
   --  ada.exceptions%s
   --  ada.exceptions.last_chance_handler%s
   --  ada.exceptions.last_chance_handler%b
   --  system.soft_links%s
   --  system.soft_links%b
   --  system.secondary_stack%b
   --  system.exception_table%s
   --  system.exception_table%b
   --  ada.io_exceptions%s
   --  ada.strings%s
   --  ada.tags%s
   --  ada.tags%b
   --  ada.streams%s
   --  gnat.os_lib%s
   --  gnat.os_lib%b
   --  interfaces.c%s
   --  interfaces.c%b
   --  interfaces.c.strings%s
   --  interfaces.c.strings%b
   --  system.assertions%s
   --  system.assertions%b
   --  system.finalization_root%s
   --  system.finalization_root%b
   --  system.memory%s
   --  system.memory%b
   --  system.standard_library%b
   --  system.unsigned_types%s
   --  ada.exceptions%b
   --  system.bit_ops%b
   --  ada.strings.maps%s
   --  ada.strings.maps%b
   --  ada.strings.fixed%s
   --  ada.strings.maps.constants%s
   --  ada.characters.handling%b
   --  ada.strings.search%s
   --  ada.strings.search%b
   --  ada.strings.fixed%b
   --  system.img_uns%s
   --  system.img_uns%b
   --  system.stream_attributes%s
   --  system.stream_attributes%b
   --  system.finalization_implementation%s
   --  system.finalization_implementation%b
   --  ada.finalization%s
   --  ada.finalization%b
   --  ada.finalization.list_controller%s
   --  ada.finalization.list_controller%b
   --  system.file_control_block%s
   --  system.file_io%s
   --  system.file_io%b
   --  ada.text_io%s
   --  ada.text_io%b
   --  system.val_bool%s
   --  system.val_util%s
   --  system.val_util%b
   --  system.val_bool%b
   --  glib%s
   --  glib%b
   --  gdk%s
   --  gdk.rectangle%s
   --  gdk.rectangle%b
   --  glib.error%s
   --  glib.error%b
   --  glib.convert%s
   --  glib.convert%b
   --  glib.glist%s
   --  glib.glist%b
   --  gdk.visual%s
   --  gdk.visual%b
   --  glib.gslist%s
   --  glib.gslist%b
   --  glib.messages%s
   --  glib.messages%b
   --  glib.values%s
   --  glib.values%b
   --  glib.xml%s
   --  glib.xml%b
   --  glib.glade%s
   --  gtk_generates%s
   --  gtk_generates%b
   --  gtkada%s
   --  gtkada.types%s
   --  gtkada.types%b
   --  glib.object%s
   --  glib.glade%b
   --  gdk.color%s
   --  gdk.cursor%s
   --  gdk.cursor%b
   --  glib.generic_properties%s
   --  glib.generic_properties%b
   --  glib.type_conversion_hooks%s
   --  glib.type_conversion_hooks%b
   --  glib.object%b
   --  gdk.color%b
   --  gdk.types%s
   --  gdk.region%s
   --  gdk.region%b
   --  gdk.event%s
   --  gdk.window%s
   --  gdk.event%b
   --  gdk.bitmap%s
   --  gdk.bitmap%b
   --  gdk.pixmap%s
   --  gdk.pixmap%b
   --  glib.properties%s
   --  glib.properties%b
   --  gtk%s
   --  gtk.enums%s
   --  gtk.enums%b
   --  gtk.glade%s
   --  gtk.glade%b
   --  gtk.object%s
   --  gtk.object%b
   --  gtk.accel_group%s
   --  gtk.accel_group%b
   --  gtk.adjustment%s
   --  gtk.adjustment%b
   --  pango%s
   --  pango.enums%s
   --  pango.enums%b
   --  pango.attributes%s
   --  pango.attributes%b
   --  pango.font%s
   --  pango.font%b
   --  gdk.font%s
   --  gdk.font%b
   --  gdk.gc%s
   --  gdk.gc%b
   --  gtk.style%s
   --  gtk.style%b
   --  pango.context%s
   --  pango.context%b
   --  pango.tabs%s
   --  pango.tabs%b
   --  pango.layout%s
   --  pango.layout%b
   --  gdk.drawable%s
   --  gdk.drawable%b
   --  gdk.rgb%s
   --  gdk.rgb%b
   --  gdk.pixbuf%s
   --  gdk.pixbuf%b
   --  gtk.widget%s
   --  gtk.widget%b
   --  gdk.window%b
   --  gtk.main%s
   --  gtk.main%b
   --  gate%b
   --  END ELABORATION ORDER

end ada_main;
